if(!dojo._hasResource["com.ibm.mm.builder.dnd.ColumnSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.ColumnSource"] = true;
/**
 * ColumnSource is the dnd source of one column in column layout page
 *
 * @Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dnd.ColumnSource");

dojo.require("com.ibm.mm.builder.WidgetCreator");

dojo.declare("com.ibm.mm.builder.dnd.ColumnSource", com.ibm.mm.builder.dnd.IndicatorSource, {

	accept: ["iWidgetDefinition", "iWidgetInstance"],
	withHandles: true,
	layout: null,
	
	onDndCancel: function(){
		if( this === dojo.dnd.manager().source ){ com.ibm.mm.builder.utils.htmlUtil.showNodes(dojo.dnd.manager().nodes); }
		this.inherited(arguments);
	},
	
	onDndStart: function(source, nodes, copy){
		if(this === source){ com.ibm.mm.builder.utils.htmlUtil.hideNodes(nodes); }
		this.inherited(arguments);
	},
	
	onDndDrop: function(source, nodes, copy, target){
        this.inherited(arguments);
		if(this == target){
			com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		}
	},
	
	onDropExternal: function(source, nodes, copy){ //this means drag wigetdef from toolbox or widgetInstance from other colun layout
		try {
			var draggedNodeId = nodes[0].id;
			var item = source.getItem(draggedNodeId);
			var type = item && item.type && item.type[0];
			if(type === "iWidgetDefinition"){
				this.layout.createWidget(item.data,this.node.id);
			} else {
				this.layout.displayWidget(item.data, this.node.id);
			}
		} catch (e) {
			var logger = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.dnd.ColumnSource");
			logger.severe("onDropExternal", e.message);
		}
	},
	
	onDropInternal: function(nodes, copy){ //this means reorder
		this.layout.displayWidget((nodes[0].id).replace(com.ibm.mm.builder.constant.skinIdPrefix, ""), this.node.id);
	},
	
	removeIndicator: function(){
		if (this.dropIndicator) {
			this.node.removeChild(this.dropIndicator.domNode);
			this.dropIndicator = null;
		}
	},
	
	createIndicator: function(e){
		this.inherited(arguments);
		var _target = e.target;
		if(!(_target.parentNode)){this.removeIndicator(); return;}				
		if(_target.className == "dropIndicator"){ return; }
		this.dropIndicator = this.dropIndicator || new com.ibm.mm.builder.dnd.ColumnSourceDNDIndicator();
		if (dojo.trim(_target.parentNode.id) == "_columnLayout_container") {
			this.referenceNode = null;
			this.node.appendChild(this.dropIndicator.domNode);
			return;
		}
		while(!(_target.getAttribute("dnddata"))){
			_target = _target.parentNode;
		}
		var p = dojo.coords(_target, true);
		//insert the indicator before the hoveredNode only when the mouse is on the top-right part of the hoveredNode
		
		this.before = this.layout.disableQuickWiring ? true : (e.clientY < (p.y + p.h*0.75) && (e.clientX > (p.x + p.w*0.2)));
		var referenceNode = this.before? _target:(this.getNextWidget(_target)); //_target.nextSibling;
		if (referenceNode) {
			this.node.insertBefore(this.dropIndicator.domNode, referenceNode);
		} else {
			this.node.appendChild(this.dropIndicator.domNode);
		}
	},
	
	getNextWidget:function(oDom){
		var next = oDom.nextSibling;
		if(next){
			return (next.className == "dropIndicator") ? next.nextSibling : next;
		}
	}
});



dojo.declare("com.ibm.mm.builder.dnd.ColumnSourceDNDIndicator", [dijit._Widget, dijit._Templated], {
	templateString: '<div dojoAttachPoint="dropIndicator" class="dropIndicator"><div class="dropIndicatorInner"></div></div>', 
	
	postCreate: function(){
		this.dropIndicator.style.height = dojo.coords(dojo.dnd.manager().avatar.node, true).h + "px";
	}
});

}
