dojo.provide("com.ibm.pb.decorations.MashupSkinSelectionMenu");

dojo.require("com.ibm.pb.logging.Loggable");
dojo.require("com.ibm.pb.localized.DojoLocalized");

dojo.declare("com.ibm.pb.decorations.MashupSkinSelectionMenu", [com.ibm.mashups.builder.model.ContextMenuLoader, com.ibm.pb.logging.Loggable], {

    subMenuID: "mashupSkinSelectionMenu",
    builderFactory: com.ibm.mashups.builder.model.Factory,
    
    constructor: function(args){
        if (args) {
            dojo.safeMixin(this, args);
        }
    },
    getItems: function(/*String*/contextMenuId, /*String*/ targetResourceId, /*String*/ targetResourceType, /*Object*/ someObject){
        var mname = "getItems", lgr = this.LOGGER, me = this;
        lgr.entering(mname, arguments);
        dfd = new com.ibm.mm.builder.DeferredImpl(this, function(deferred, sync, params){
            var callBack = deferred.getFinishedCallback(), callBackParams = deferred.getFinishedCallbackParameters(), ret = this._getItem(targetResourceId);
            if (callBack) {
                callBack(ret, 200, callBackParams);
            }
            return ret;
        });
        lgr.exiting(mname, arguments);
        return dfd;
    },
    
    _getItem: function(targetResourceId){
        if (this.builderFactory.getRuntimeModel().getCurrentPage().getPageMode() == "view") {
            return [];
        }
        else {
            var ret = [];
            var item = {
                id: "skin:Selection",
                localized: new com.ibm.pb.localized.DojoLocalized({
                    bundlePackage: "com.ibm.bundles",
                    bundleName: "Theme",
                    bundleKey: "theme_choose_skin"
                }),
                contextMenuID: this.subMenuID,
                //resourceType:,
                //resourceId:,
                enabled: true,
                ordinal: 140
            };
            ret.push(item);
            return ret;
        }
    }
});

dojo.declare("com.ibm.pb.decorations.MashupSkinItems", com.ibm.pb.decorations.MashupSkinSelectionMenu, {

    subMenuID: "",
    
    registerMenu: function(menuID){
        var cmm = this.builderFactory.getContextMenuModel();
        cmm.registerContextMenu(menuID, this);
    },
    
    _getItem: function(targetResourceId){
        var ret = [], ordinal = 1;
        dojo.forEach(com.ibm.mm.builder.utils.skinUtil.getAllSkins(), function(skin){
			var checked = false;
            var skinId = skin.getID();
            var layoutControl = com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetId(targetResourceId);
			if(!layoutControl) return;
            var skinTitle = skin.getTitle(dojo.locale);
			var currentSkin = layoutControl.getSkin();
			var currentSkinId = "";
			if (currentSkin) {
				currentSkinId = currentSkin.getID();
			} else {
				var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
				var nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
				var page = nm.find(pageId).start();
				var themeId = page.getTheme();
				var theme = com.ibm.mashups.enabler.model.Factory.getThemeModel().find(themeId).start();
				currentSkinId = theme.getDefaultSkin();
			}
			if (skinId === currentSkinId) {
				checked = true;
				skinTitle = skinTitle + "<span class = 'access'>" + com.ibm.mm.builder.coreWidgetsStrings.I_MODE_IS_SELECT + "</span>";
			}
            var item = {
                id: "skin:" + skinId,
                title: skinTitle,
                enabled: true,
                ordinal: ordinal++,
                actionCallBackFunction: this._switchToSkin(skinId, targetResourceId),
				checkedMenuItem:true,
				checked:true
            };
            dojo.mixin(item, {
				checked:checked,
                iconClass: (skinId === currentSkinId ? "menuIconClass" : "")
            });
            ret.push(item);
        }, this);
        return ret;
    },
    
    _switchToSkin: function(skinId, widgetId){
        return function(){
            var layoutControl = com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetId(widgetId);
            layoutControl.setSkin(skinId);
            com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.layoutRefresh", widgetId);
        }
    }
});
