if(!dojo._hasResource["com.ibm.widgets.InlineShelf"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.InlineShelf"] = true;
 // This is a dropdown inline shelf

dojo.provide("com.ibm.widgets.InlineShelf");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare("com.ibm.widgets.InlineShelf",
	[dijit._Widget, dijit._Templated],
	{
		content: null,				// HTML content to display in the shelf
		link: null,					// an id or DOM element to which the shelf's toggle function should be attached
		shelfClass: "",				// css classes to put on the shelf
		displayState: "closed",		// state of the shelf, ie "open", "closed"
		everOpened: false,			// true when the shelf has been opened before
		wipeOut: null,				// animation to slide the shelf out of view
		wipeIn: null,				// animation to slide the shelf into view
		wipeTime: 300,				// the time the shelf takes to slide in/out in milliseconds
		templateString: '<div dojoAttachPoint="focusNode" style="display: none;" class="${shelfClass}"></div>',
		
		startup: function(){
			// create the hide/show animations
			this.wipeOut = dojo.fx.wipeOut({node:this.domNode, duration:this.wipeTime});
			this.wipeIn = dojo.fx.wipeIn({node:this.domNode, duration:this.wipeTime});
			
			// add the content
			if(this.content) this.domNode.appendChild(this.content);
			this.onCreate();
		},
		
		connectButton: function(){
			// set the onclick handler for the toggle link
			if (dojo.isString(this.link)) this.link = dojo.byId(this.link);
			if(this.link && !this.buttonConnection) {
				this.buttonConnection = dojo.connect(this.link, "onclick", this, this.toggleDisplay);
				dojo.removeClass(this.link,"lotusBtnDisabled");
			}
		},
		
		disconnectButton: function(){
			// set the onclick handler for the toggle link
			if(this.displayState == "open") this.toggleDisplay();
			if(this.buttonConnection) {
				dojo.disconnect(this.buttonConnection);
				this.buttonConnection = null;
			}
			if(this.link) dojo.addClass(this.link, "lotusBtnDisabled");
		},
		
		toggleDisplay: function(){
			// summary: changes the state of the display
			if(this.displayState == "open") {
				this.displayState = "closed";
				this.onClose();
				if(dojo.isIE) dojo.style(this.domNode,"display","none");
				else this.wipeOut.play();
				if (this.link) {
					dojo.removeClass(this.link, "ibmCompressed");
				}
			} else if (this.displayState == "closed"){
				this.displayState = "open";
				this.onOpen();
				if(!this.everOpened) { this.startup(); }
				if(dojo.isIE) dojo.style(this.domNode,"display","");
				else this.wipeIn.play();
				if(!this.everOpened) { this.onFirstOpen(); this.everOpened = true; }
				if (this.link) {
					dojo.addClass(this.link, "ibmCompressed");
				}
			}
		},
		
		onCreate: function(){
			// summary: stub event for when the shelf is instantiated
		},
		
		onOpen: function(){
			// summary: stub event for when the shelf is displayed
		},
		
		onFirstOpen: function(){
			// summary: stub event for when the shelf is opened for the first time
		},
		
		onClose: function(){
			// summary: stub event for when the shelf is hidden
		}
});

}
