/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.persistence.ModelPersistenceProvider");

dojo.declare("com.ibm.mashups.enabler.persistence.ModelPersistenceProvider", null, {

    /**
     * Returns the selected objects.<br>
     *
     * @param {com.ibm.mashups.enabler.model.url.ModelUrl} url url that specifies the object(s) to find
     * @param {Object} selection selection criteria; for details on the selection object, refer
     * to the model specific documentation
     * @param {Object} callback callback function, which is called with the following arguments:
     * <tt>function(result, status, parameters)</tt>, where<br>
     * <ul>
     * <li><tt>result</tt> is an array containing the selected objects; may contain zero or more objects</li>
     * <li><tt>status</tt> status code of the operation</li>
     * <li><tt>parameters</tt> are the parameters as passed into <tt>findBySelection</tt></li>
     * </ul>
     * @param {Object} parameters parameters to pass to the callback function; optional
     * @type void
     *
     * @ibm-spi
     */
    findBySelection: function(url, selection, callback, parameters){
    },
    
    /**
     * Creates an object based on a given context.<br>
     * @param {Object} context context defining properties for the object to create; for
     * details on the selection object, refer to the model specific documentation
     * @return {Object} new object
     *
     * @ibm-spi
     */
    create: function(context){
    },
    
    /**
     * Removes the specified objects.
     *
     * @param {Array} objects array of objects to remove
     * @param {Object} callback callback function, which is called with the following arguments:
     * <tt>function(status, parameters)</tt>, where<br>
     * <ul>
     * <li><tt>status</tt> status code of the operation</li>
     * <li><tt>parameters</tt> are the parameters as passed into <tt>remove</tt></li>
     * </ul>
     * @param {Object} parameters parameters to pass to the callback function; optional
     * @type void
     *
     * @ibm-spi
     */
    remove: function(objects, callback, parameters){
    },
    
    /**
     * Stores the specified objects.
     *
     * @param {Array} objects array of objects to store.
     * @param {Object} callback callback function, which is called with the following arguments:
     * <tt>function(status, parameters)</tt>, where<br>
     * <ul>
     * <li><tt>status</tt> status code of the operation</li>
     * <li><tt>parameters</tt> are the parameters as passed into <tt>store</tt></li>
     * </ul>
     * @param {Object} parameters parameters to pass to the callback function; optional
     * @type void
     *
     * @ibm-spi
     */
    store: function(objects, callback, parameters){
    },
    /**
     * Returns the modifiable node of the provided node, if <code>node</code> is not already modifiable.
     * 
     * @param {Identifiable} node the node to get the modifiable for.
     * @type {Identifiable}
     * 
     * @ibm-spi
     */
    getModifiable: function(node) {
    }
});
